// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Լ 
int putchar_0(char data);					// COM1 ۽
int getchar_0(void);						// COM1 

//  
char com1_rx_data,com1_rx_eflg = 0;				//   ͷƮ  /÷

int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī
int timer1_cnt = 0;						// Ÿ̸1 ͷƮ  ī
int timer2_cnt = 0;						// Ÿ̸2 ͷƮ  ī

int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
int exint1_flg = 0;						// EXINT1 ͷƮ  ÷
int exint2_flg = 0;						// EXINT2 ͷƮ  ÷

unsigned int adc_int_data = 0;					// ADC ͷƮ  
int adc_int_ch = 0;						// ADC CH ͷƮ 
int adc_int_flg = 0;						// ADC ͷƮ  ÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{

// PortA 
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)
// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortC 
	PORTC=0x00;						// Ʈ  reg             
	DDRC=0x00;                                              // Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg             
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	TCCR0=0x00;
	TCNT0=0x00;
	OCR0=0x00;

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;

// Timer/Counter2 
	ASSR=0x00;
	TCCR2=0x00;
	TCNT2=0x00;
	OCR2=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
	MCUCR=0x00;
	MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK=0x00;

//  ʱȭ
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSRA=0x00;
	UCSRB=0x98;
	UCSRC=0x86;
	UBRRH=0x00;
	UBRRL=0x33;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

	fdevopen(putchar_0,getchar_0,0);
// Global enable interrupts
	sei();
}

// ================================  ͷƮ =============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_UART_RECV)
{
char status,data;

	status=UCSRA;
	data=UDR;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}
}

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
SIGNAL(SIG_OVERFLOW0)
{
	TCNT0 = 99;						// 255-156 = 100
	timer0_cnt++;						// Ÿ̸0 ī
}

// ========================== TIMER1 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
// ----------------------------------------------------------------------------
SIGNAL(SIG_OVERFLOW1)
{
	TCNT1 = 63035;						// 65535 - 2500 = 63035
	timer1_cnt++;						// Ÿ̸1 ī
}

// ========================== TIMER2 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
SIGNAL(SIG_OVERFLOW2)
{
	TCNT2 = 99;						// 255-156 = 100
	timer2_cnt++;						// Ÿ̸2 ī
}

// ========================== ܺ INT0 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT0)
{
	exint0_flg = 1;						// EXINT0 ÷ ON
}

// ========================== ܺ INT1 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT1)
{
	exint1_flg = 1;						// EXINT1 ÷ ON
}

// ========================== ܺ INT2 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_INTERRUPT2)
{
	exint2_flg = 1;						// EXINT2 ÷ ON
}

// =============================== ADC ͷƮ ===============================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_ADC)
{
	adc_int_data = ADCW;					// ADC
	adc_int_flg = 1;					// ADC Ϸ ÷ 
}

// ============================== COM1 1Ʈ ۽ =========================
// [μ] char data
// item1:  
// --------------------------------------------------------------------------
int putchar_0(char data)
{
	if(data == '\n'){
		while((UCSRA & DATA_REGISTER_EMPTY) == 0);
		UDR = '\r';
	}
	while((UCSRA & DATA_REGISTER_EMPTY) == 0);
	UDR = data;
	return(0);
}

// ============================== COM1 1Ʈ  =========================
// [μ] void
// []  
// --------------------------------------------------------------------------
int getchar_0(void)
{
	while((UCSRA & RX_COMPLETE) == 0);
	return(UDR);
}
