// =========================== Atmega32 CPU ׽Ʈ α׷ ===================
//  CPU : ATmega32-16M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega32


#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADCSR=6;     // for compatibility with older code
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions




// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for character type functions


#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-


/* CodeVisionAVR C Compiler
   (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L. */







//  
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   


//  
char com1_rx_data,com1_rx_eflg = 0;				//   ͷƮ  /÷

int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī
int timer1_cnt = 0;						// Ÿ̸1 ͷƮ  ī
int timer2_cnt = 0;						// Ÿ̸2 ͷƮ  ī

int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
int exint1_flg = 0;						// EXINT1 ͷƮ  ÷
int exint2_flg = 0;						// EXINT2 ͷƮ  ÷

unsigned int adc_int_data = 0;					// ADC ͷƮ  
int adc_int_ch = 0;						// ADC CH ͷƮ 
int adc_int_flg = 0;						// ADC ͷƮ  ÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{

// PortA 
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)
// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortC 
	PORTC=0x00;						// Ʈ  reg             
	DDRC=0x00;                                              // Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg             
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
	TCCR0=0x00;
	TCNT0=0x00;
	OCR0=0x00;

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;

// Timer/Counter2 
	ASSR=0x00;
	TCCR2=0x00;
	TCNT2=0x00;
	OCR2=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
	MCUCR=0x00;
	MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK=0x00;

//  ʱȭ
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSRA=0x00;
	UCSRB=0x98;
	UCSRC=0x86;
	UBRRH=0x00;
	UBRRL=0x33;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

// Global enable interrupts
#asm("sei")
}

// ================================  ͷƮ =============================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [14] void uart_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status=UCSRA;
	data=UDR;
	if((status & ((1<<4) | (1<<2) | (1<<3)))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [12] void timer0_ovf_isr(void)
{
	TCNT0 = 99;						// 255-156 = 100
	timer0_cnt++;						// Ÿ̸0 ī
}

// ========================== TIMER1 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
// ----------------------------------------------------------------------------
interrupt [10] void timer1_ovf_isr(void)
{
	TCNT1 = 63035;						// 65535 - 2500 = 63035
	timer1_cnt++;						// Ÿ̸1 ī
}

// ========================== TIMER2 overflow ͷƮ ========================
// [μ] void
// [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [6] void timer2_ovf_isr(void)
{
	TCNT2 = 99;						// 255-156 = 100
	timer2_cnt++;						// Ÿ̸2 ī
}

// ========================== ܺ INT0 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [2] void ext_int0_isr(void)
{
	exint0_flg = 1;						// EXINT0 ÷ ON
}

// ========================== ܺ INT1 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [3] void ext_int1_isr(void)
{
	exint1_flg = 1;						// EXINT1 ÷ ON
}

// ========================== ܺ INT2 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [4] void ext_int2_isr(void)
{
	exint2_flg = 1;						// EXINT2 ÷ ON
}

// =============================== ADC ͷƮ ===============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [17] void adc_isr(void)
{
	adc_int_data = ADCW;					// ADC
	adc_int_flg = 1;					// ADC Ϸ ÷ 
}

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void cpu_ioport_output(void);					// CPU PORT I/O ׽Ʈ
void timer0_test(void);						// TIMER0 TEST
void timer1_test(void);						// TIMER1 TEST
void timer2_test(void);						// TIMER2 TEST
void exint_test(void);						// EXINT0,1 TEST
void ad_polling_test(void);					// A/D   TEST
unsigned int ad_read(unsigned char adc_input);			// A/D  ( )
void ad_interrupt_test(void);					// A/D ͷƮ  TEST
void ad_start(unsigned char adc_input);				// AD  (ͷƮ ) 
void eeprom_test(void);						// EEPROM TEST
void EEPROM_write(int addr,unsigned char data);			// EEPROM  
unsigned char EEPROM_read(int addr);				// EEPROM  

void urx_string(char buff[]);					// Ʈ 
long atoh(char buff[]);						// ASCII TO HEX 

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
void main(void)
{
	cpu_setup();						// cpuʱȭ
	main_menu_disp();					//  ޴ ǥ
	while(1){						// Place your code here
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
			else if(com1_rx_data == '2') timer0_test(); // TIMER0 TEST
			else if(com1_rx_data == '3') timer1_test(); // TIMER1 TEST
			else if(com1_rx_data == '4') timer2_test(); // TIMER2 TEST
			else if(com1_rx_data == '5') exint_test();  // EXINT0,1 TEST
			else if(com1_rx_data == '6') ad_polling_test();// A/D POLLING TEST
			else if(com1_rx_data == '7') ad_interrupt_test(); // A/D POLLING TEST
			else if(com1_rx_data == '8') eeprom_test(); // EEPROM TEST
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
}

// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("=================== MAIN MENU ==================\r\n");
	printf("- 1  : CPU I/O PORT TEST                        \r\n");
	printf("- 2  : TIMER0 TEST                              \r\n");
	printf("- 3  : TIMER1 TEST                              \r\n");
	printf("- 4  : TIMER2 TEST                              \r\n");
	printf("- 5  : EXINT0,1,2 TEST                          \r\n");
	printf("- 6  : A/D POLLING   TEST                       \r\n");
	printf("- 7  : A/D INTERRUPT TEST                       \r\n");
	printf("- 8  : EEPROM TEST                              \r\n");
	printf("----------------- CPUPLAZA ---------------------\r\n");
}

// ============================== CPU_IO TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void cpu_ioport_output(void)
{
int out_cnt,exit_flg = 0;

	printf("================ CPU I/O PORT TEST ==============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("-------------------------------------------------\r\n");
// CPU PORT   
// PORTA[0..7] : OUT 
	PORTA=0xff;						// Ʈ  reg
	DDRA=0xff;						// Ʈ  reg(0Է,1)
// CPU PORT   
// PORTB[0..7] : OUT 
	PORTB=0xff;						// Ʈ  reg
	DDRB=0xff;						// Ʈ  reg(0Է,1)
// PORTC[0..5] : OUT 
	PORTC=0xff;						// Ʈ  reg
	DDRC=0xff;						// Ʈ  reg(0Է,1)
// PORTD[2..7] : OUT 
	PORTD=0xfc;						// Ʈ  reg
	DDRD=0xfc;						// Ʈ  reg(0Է,1)

// LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
	TCCR0 = 0x05;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99	
	OCR0 = 0x00;
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡

	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	out_cnt = 0;
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 50){				// 500ms  
			if(out_cnt >= 0 && out_cnt < 8) PORTA = ~(1 << out_cnt);// PORTA (ش Ʈ 0)
			else if(out_cnt >= 8 && out_cnt < 16){	// PORTB 
				if(out_cnt == 8) PORTA = 0xff;	// PORTA CLEAR
				PORTB = ~(1 << (out_cnt-8));	// PORTB (ش Ʈ 0)
			}
			else if(out_cnt >= 16 && out_cnt < 24){	// PORT C 
				if(out_cnt == 16) PORTB = 0xff;	// PORTB CLEAR
				PORTC = ~(1 << (out_cnt-16));	// PORTC (ش Ʈ 0)
			}
			else if(out_cnt >= 24 && out_cnt < 30){	// PORTD 
				if(out_cnt == 24) PORTC = 0xff;	// PORTC CLEAR
				PORTD = ~(4 << (out_cnt-24));	// PORTD (ش Ʈ 0)
			}
			out_cnt++;				//  ġ ī 
			if(out_cnt >= 32) out_cnt = 0;		//  ġ ʰ ˻
			if(out_cnt == 0){			//  ü ʱȭ
				PORTA = 0xff;
				PORTB = 0xff;
				PORTC = 0xff;
				PORTD = 0xfc;
			}
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0 = 0x00;
	TCNT0 = 0;	
	OCR0 = 0x00;
	TIMSK &= 0xfe;						// TIMER0 ͷƮ 

// CPU PORT ʱⰪ  
// PORTA
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)
// PORTB
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)
// PORTC
	PORTC=0x00;						// Ʈ  reg
	DDRC=0x00;						// Ʈ  reg(0Է,1)
// PORTD
	PORTD=0x00;						// Ʈ  reg
	DDRD=0x00;						// Ʈ  reg(0Է,1)
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER0 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer0_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER0 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER0 Overfow 9.9984ms         \r\n");
	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter0 (Overflow)
	TCCR0 = 0x05;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99	
	OCR0 = 0x00;
	TIMSK |= 0x01;						// TIMER0 ͷƮ 㰡
	
	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 100){				// 999.84ms üũ
			printf("TIMER0 Overflow Interrupt\r\n");
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0 = 0x00;
	TCNT0 = 0;	
	OCR0 = 0x00;
	TIMSK &= 0xfe;						// TIMER0 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER1 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer1_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER1 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER1 Overfow 10.0ms           \r\n");
	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter1 (Overflow)
	TCCR1A = 0x00;
	TCCR1B = 0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	TCNT1 = 63035;						// 65535 - 2500 = 63035
	OCR1AH = 0x00;
	OCR1AL = 0x00;
	OCR1BH = 0x00;
	OCR1BL = 0x00;	
	TIMSK |= 0x04;						// TIMER1 ͷƮ 㰡

	timer1_cnt = 0;						// TIMER1 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){					// COM1  ˻
		if(com1_rx_eflg){
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer1_cnt >= 100){				// 1s üũ
			printf("TIMER1 Overflow Interrupt\r\n");
			timer1_cnt = 0;
		}
	}

// Timer/Counter1 
	TCCR1A = 0x00;
	TCCR1B = 0x00;
	TCNT1H = 0x00;
	TCNT1L = 0x00;
	OCR1AH = 0x00;
	OCR1AL = 0x00;
	OCR1BH = 0x00;
	OCR1BL = 0x00;	
	TIMSK &= 0xfb;						// TIMER1 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER2 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer2_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER2 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER0 Overfow 9.9984ms         \r\n");
	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter2 (Overflow)
	ASSR = 0x00;
	TCCR2 = 0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT2 = 99;						// 255-156 = 99
	OCR2 = 0x00;
	TIMSK |= 0x40;						// TIMER2 ͷƮ 㰡

	timer2_cnt = 0;						// TIMER2 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer2_cnt >= 100){				// 999.84ms üũ
			printf("TIMER2 Overflow Interrupt\r\n");
			timer2_cnt = 0;
		}
	}

// Timer/Counter2 
	ASSR = 0x00;
	TCCR2 = 0x00;
	TCNT2 = 0;
	OCR2 = 0x00;
	TIMSK &= 0xbf;						// TIMER2 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== EXINT0,1 TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void exint_test(void)
{
int exit_flg = 0;

	printf("=================== EXINT0,1 TEST ===============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt : INT0 Falling Edge                  \r\n");
	printf("-             INT1 Falling Edge                  \r\n");
	printf("-             INT2 Falling Edge                  \r\n");
	printf("-------------------------------------------------\r\n");

// External Interrupt(s) 
// INT0 Mode: Falling Edge
// INT1 Mode: Falling Edge
// INT2 Mode: Falling Edge
	GICR|=0xE0;
	MCUCR=0x0A;
	MCUCSR=0x00;
	GIFR=0xE0;

	exint0_flg = exint1_flg = exint2_flg = 0;		// EXINT0,1 ͷƮ ÷ Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
			printf("EXINT0 Interrupt\r\n");
			exint0_flg = 0;
		}
		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
			printf("EXINT1 Interrupt\r\n");
			exint1_flg = 0;
		}
		if(exint2_flg){					// EXINT2 ͷƮ ÷ üũ
			printf("EXINT2 Interrupt\r\n");
			exint2_flg = 0;
		}
	}

// External Interrupt(s) 
	GICR&=0x1f;
	MCUCR=0x00;
	MCUCSR=0x00;
	GIFR=0x00;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_polling_test(void)
{
unsigned datau;
int exit_flg = 0;

	printf("================= A/D POLLING TEST ==============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- 1  : CH0 READ                                  \r\n");
	printf("- 2  : CH1 READ                                  \r\n");
	printf("- 3  : CH2 READ                                  \r\n");
	printf("- 4  : CH3 READ                                  \r\n");
	printf("- 5  : CH4 READ                                  \r\n");
	printf("- 6  : CH5 READ                                  \r\n");
	printf("- 7  : CH6 READ                                  \r\n");
	printf("- 8  : CH7 READ                                  \r\n");
	printf("-------------------------------------------------\r\n");

// ADC initialization 
	ADMUX = 0x00;						//   AREF
	ADCSRA = 0x87;						// ADC Enable,ADC Clock 125.000Khz
	SFIOR &= 0xEF;

	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') datau = ad_read(0);// CH0 
			else if(com1_rx_data == '2') datau = ad_read(1);// CH1 
			else if(com1_rx_data == '3') datau = ad_read(2);// CH2 
			else if(com1_rx_data == '4') datau = ad_read(3);// CH3 
			else if(com1_rx_data == '5') datau = ad_read(4);// CH4 
			else if(com1_rx_data == '6') datau = ad_read(5);// CH5 
			else if(com1_rx_data == '7') datau = ad_read(6);// CH6 
			else if(com1_rx_data == '8') datau = ad_read(7);// CH7 
			else putchar(com1_rx_data);		// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("ADC CH%d > %d\r\n",(com1_rx_data&0x0f)-1,datau);
			com1_rx_eflg = 0;
		}
	}

// ADC initialization 
	ADMUX = 0x00;
	ADCSRA = 0x00;
	SFIOR &= 0xEF;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
unsigned int ad_read(unsigned char adc_input)
{
	ADMUX = adc_input;					// ADREF(0) + CH
	ADCSRA |= 0x40;						// AD conversion 
	while((ADCSRA & 0x10) == 0);				//  Ϸ 
	ADCSRA |= 0x10;						// AD ÷ Ŭ
	return ADCW;
}

// ============================== A/D INTERRUPT TEST ==========================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_interrupt_test(void)
{
int exit_flg = 0;

	printf("================ A/D INTEERRUPT TEST ============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- 1  : CH0 READ                                  \r\n");
	printf("- 2  : CH1 READ                                  \r\n");
	printf("- 3  : CH2 READ                                  \r\n");
	printf("- 4  : CH3 READ                                  \r\n");
	printf("- 5  : CH4 READ                                  \r\n");
	printf("- 6  : CH5 READ                                  \r\n");
	printf("- 7  : CH6 READ                                  \r\n");
	printf("- 8  : CH7 READ                                  \r\n");
	printf("-------------------------------------------------\r\n");

// ADC initialization 
	ADMUX = 0x00;						//   AREF
	ADCSRA = 0x8f;						// ADC Enable,ADC Clock 125.000Khz,ADC ȯ ͷƮ Ȱȭ
	SFIOR &= 0xEF;
	
	adc_int_flg = 0;					// ADCϷ ͷƮ ÷
	adc_int_ch = 0;						// ADC CH = CH0
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') ad_start(0);// CH0 
			else if(com1_rx_data == '2') ad_start(1);// CH1 
			else if(com1_rx_data == '3') ad_start(2);// CH2 
			else if(com1_rx_data == '4') ad_start(3);// CH3 
			else if(com1_rx_data == '5') ad_start(4);// CH4 
			else if(com1_rx_data == '6') ad_start(5);// CH5 
			else if(com1_rx_data == '7') ad_start(6);// CH6 
			else if(com1_rx_data == '8') ad_start(7);// CH7 
			else putchar(com1_rx_data);		// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("STAT ADC ");
			com1_rx_eflg = 0;
		}
		if(adc_int_flg){				// ADC  Ϸ ͷƮ ÷ 
			printf("CH%d > %d\r\n",adc_int_ch,adc_int_data);// ADC CH  ǥ
			adc_int_flg = 0;
		}
	}

// ADC initialization 
	ADMUX = 0x00;
	ADCSRA = 0x00;
	SFIOR &= 0xEF;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
void ad_start(unsigned char adc_input)
{
	adc_int_ch = adc_input;					// ADC CH 
	ADMUX = adc_input;					// ADREF(0) + CH
	ADCSRA |= 0x40;						// AD conversion 
}

// ================================ EEPROM TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void eeprom_test(void)
{
char ch,buff[100],buff1[30],buff2[30],buff3[30];
unsigned char uch;
int i,j,cnt,exit_flg = 0;
unsigned int saddr,ecnt;

	printf("============== INTERNAL EEPROM TEST =============\r\n");
	printf("- 0 : TOP menu                                   \r\n");
	printf("  1 : Read  Data(000-3ffh)                       \r\n");
	printf("  2 : Write Data(000-3ffh)                       \r\n");
	printf("-------------------------------------------------\r\n");

	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1'){
				i = j = cnt = 0;
				printf("\r\nREAD(###(Add),***(Count)) > ");
				urx_string(buff);
				ch = buff[i++];			//  ˻ ڷ 
				while(ch != 0x0){
					if((ch == ':') || (ch == ',') || (ch == ' ')){
						j = 0;
						cnt++;
					}
					else{
						if(cnt == 0){
							buff1[j++] = ch;
							buff1[j] = 0x0;
						}
						else if(cnt == 1){
				    			buff2[j++] = ch;
				    			buff2[j] = 0x0;
						}
			    		}
				    	ch = buff[i++];
				}
				if(cnt == 1){			// ˻ 
					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
					ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
					printf("%04X > ",saddr);// ּ ǥ
					cnt = 0;
			   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ	
						uch = EEPROM_read(saddr);//  
						printf("%02X ",uch);// Ÿ ǥ
						cnt++;
						if(cnt == 16){// 1 ǥ
							cnt = 0;
							if(i+1 <= ecnt) printf("\r\n%04X > ",saddr+1);// ּ ǥ
						}
				    	}
					printf("\r\nRead OK\r\n");
				}
			}
			else if(com1_rx_data == '2'){
				i = j = cnt = 0;
				printf("\r\nWRITE(###(Addr),***(Count),**(Data)) > ");
				urx_string(buff);
				ch = buff[i++];			//  ˻ ڷ 
				while(ch != 0x0){
					if((ch == ':') || (ch == ',') || (ch == ' ')){
						j = 0;
						cnt++;
					}
					else{
						if(cnt == 0){
							buff1[j++] = ch;
							buff1[j] = 0x0;
						}
						else if(cnt == 1){
							buff2[j++] = ch;
							buff2[j] = 0x0;
						}
						else if(cnt == 2){
							buff3[j++] = ch;
							buff3[j] = 0x0;
						}
					}
					ch = buff[i++];
				}
				if(cnt == 2){			// ˻ 
					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
					ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
					uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
					for(i = 0; i <= ecnt; i++,saddr++) EEPROM_write(saddr,uch);//  
					printf("SRAM Data Write OK\r\n");
				}
			}
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
	}
	main_menu_disp();					//  ޴ ǥ
}

// ============================== EEPROM DATA READ ============================
// [μ] int addr
// Item1:  ּ(0 - 1023)
// []  (00 - ff)
// ----------------------------------------------------------------------------
unsigned char EEPROM_read(int addr)
{
unsigned char ch;

	while(EECR & 0x02);					//   Ϸñ 
	EEAR = addr;
	EECR |= 0x01;
	ch = EEDR;
	return(ch);
}

// ============================== EEPROM DATA  ============================
// [μ] int addr,unsigned char data
// Item1:  ּ(0 - 1023)
// Item2:  (00 - ff)
// ----------------------------------------------------------------------------
void EEPROM_write(int addr,unsigned char data)
{
	while(EECR & 0x02);					//   Ϸñ 
	EEAR = addr;
	EEDR = data;
	EECR |= 0x04;
	EECR |= 0x02;
}

// ============================ κ ڿ  ====================
// [μ] char buff[]					     
// Item1   Ÿ  (ִ 30)			     
// ----------------------------------------------------------------------------
void urx_string(char buff[])
{
char ch;
int exit_flg = 0,scnt = 0;

	com1_rx_eflg = 0;
	buff[0] = 0x0;						//  ũ
	while(exit_flg == 0){
	    while(com1_rx_eflg == 0); com1_rx_eflg = 0;		// 1 
	    ch = com1_rx_data;					//  Ÿ ε
	    ch = toupper(ch);					//  ȯ
	    if(ch == 0x08){					// BSŰ м
			if(scnt == 0) putchar(0x07);		//  溸 ۽
			else{					// 1ڸ 
			    putchar(0x08);
			    putchar(' ');
			    putchar(0x08);
			    scnt--;
			}
	    }
	    else if(ch == 0x0d){
			exit_flg = 1;				// Ż  ON
			buff[scnt] = 0x0;
			printf("\r\n");
	    }
	    else{
			buff[scnt++] = ch;			// ڷ 
			putchar(ch);
			if(scnt >= 30){ 			//   ʰ 
			    scnt = 29;
			    putchar(0x08);
			    putchar(0x07);
			}
	    }
	}
}

// ========================== ASCII͸ HEXͷ ȯ ==================
// [μ] unsigned char buff[]					    
// Item1  ȯ  					    
// [] 0 - 7fffffffh 					    
// ----------------------------------------------------------------------------
long atoh(char buff[])
{
char ch;
int i = 0;
long data = 0;

	ch = buff[i++]; 					//  ε
	ch = toupper(ch);					// 빮 ȯ
	while(ch != 0){
		ch = ch - '0';              			// 0 - 9 ȯ 
		if(ch > 9) ch = ch - 7;				// A - F ȯ
		if(ch < 0 || ch > 0x0f) ch = 0;			//  ˻
		else ch = ch & 0x0f;
		data = data << 4;				// ȯ  
		data |= ch;
		ch = buff[i++];					//  ε
		ch = toupper(ch);				// 빮 ȯ 
	}
	return(data);
}
